<template>
  <NuxtLink
    v-slot="{ navigate }"
    custom
    :to="beneficiaryLink"
    target="_self"
  >
    <tr
      class="clickable-row"
      @click="navigate"
    >
      <td>{{ lastname }}</td>
      <td>{{ nameOrEmpty(beneficiary.firstname) }}</td>
      <td>
        <template v-if="beneficiary.birthdate">
          {{ age(beneficiary.birthdate) }} ans
        </template>
      </td>
      <td>{{ formatDate(beneficiary.birthdate) }}</td>
      <td class="address-data">
        {{ beneficiary.street_number }} {{ beneficiary.street }}
      </td>
      <td>{{ beneficiary.city }}</td>
      <td>{{ beneficiary.phone_1 }}</td>
      <td class="follow-up-types-data">{{ followUpTypes }}</td>
      <td>{{ referents }}</td>
      <td>{{ STATUS_OPTIONS.get(beneficiary.status) }}</td>
      <td>{{ readableFileNumber(beneficiary.id) }}</td>
    </tr>
  </NuxtLink>
</template>

<script setup>
  import { agentName, age, formatDate, readableFileNumber } from '~/utils'
  import { ORIGIN_PAGE_PARAMETER } from '~~/utils/constants'
  import { STATUS_OPTIONS } from '~/utils/constants/beneficiary'
  import { nameOrEmpty } from '~~/utils/beneficiary'
  import { Routes } from '~/utils/routing/routes'

  const { $getBeneficiaryFollowUpTypes } = useNuxtApp()

  const route = useRoute()

  const props = defineProps({
    beneficiary: { type: Object, required: true }
  })

  const beneficiaryLink = computed(() => {
    return {
      path: Routes.Beneficiary(props.beneficiary.id),
      query: {
        [ORIGIN_PAGE_PARAMETER]: route.path
      }
    }
  })

  const followUpTypes = computed(() =>
    $getBeneficiaryFollowUpTypes(props.beneficiary)
      .map(({ name }) => name)
      .join(', ')
  )

  const referents = computed(() =>
    props.beneficiary.referents
      .map(({ referent }) => agentName(referent))
      .join(', ')
  )

  const lastname = computed(() => {
    if (props.beneficiary.usual_name) {
      return props.beneficiary.usual_name.toUpperCase()
    }
    if (props.beneficiary.birth_name) {
      return `(${props.beneficiary.birth_name.toUpperCase()})`
    }
    return nameOrEmpty(props.beneficiary.usual_name)
  })
</script>

<style lang="scss" scoped>
  .address-data {
    max-width: 15rem;
  }

  .follow-up-types-data {
    max-width: 25rem;
  }
</style>
